using Vintagestory.API.Common;
using Vintagestory.API.Server;
using Vintagestory.API.Util; // Needed for `Append` to work.
using System;

namespace FreeStoneDropsWhenBrokenMod
{
    class Core : ModSystem
    {
		public override bool ShouldLoad(EnumAppSide side)
        {
			return side == EnumAppSide.Server;
		}

        public override void StartServerSide(ICoreServerAPI api)
        {
            base.StartServerSide(api);
            api.RegisterBlockBehaviorClass("BlockBehaviorFreeStoneDropsWhenBroken", typeof(BlockBehaviorFreeStoneDropsWhenBroken));
            api.World.Logger.Event("Started 'FreeStoneDropsWhenBroken' mod.");
        }
           
        public override void AssetsFinalize(ICoreAPI api)
        {
            foreach (Block block in api.World.Blocks)
            {
                if (ModSupportsThisBlock(block))
                {
                    block.BlockBehaviors = block.BlockBehaviors.Append(new BlockBehaviorFreeStoneDropsWhenBroken(block));
                }               
            }
        }

        private bool ModSupportsThisBlock(Block block)
        // For now let's support rock, cracked rock, ores, meteoric iron.
        {
            try
            {
                string s = block.ToString();
                return s.Contains("rock-") || s.Contains("ore-") || s.Contains("meteor");
            }
            catch (NullReferenceException) // Skip null blocks and null block.ToString().
            {
                return false;
            }
        }
    }
}
